"""
    lodgea-python

    LODGEA SDK for Python. Check out https://docs.lodgea.io for more information.  # noqa: E501

    The version of the OpenAPI document: 1.1.0
    Contact: support@lodgea.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from lodgea-python.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from lodgea-python.exceptions import ApiAttributeError



class AvailabilitySearchPostRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('currency_code',): {
            'AED': "AED",
            'ARS': "ARS",
            'AUD': "AUD",
            'AZN': "AZN",
            'BGN': "BGN",
            'BHD': "BHD",
            'BRL': "BRL",
            'CAD': "CAD",
            'CHF': "CHF",
            'CLP': "CLP",
            'CNY': "CNY",
            'COP': "COP",
            'CZK': "CZK",
            'DKK': "DKK",
            'EGP': "EGP",
            'EUR': "EUR",
            'FJD': "FJD",
            'GBP': "GBP",
            'GEL': "GEL",
            'HKD': "HKD",
            'HUF': "HUF",
            'IDR': "IDR",
            'ILS': "ILS",
            'INR': "INR",
            'JOD': "JOD",
            'JPY': "JPY",
            'KRW': "KRW",
            'KWD': "KWD",
            'KZT': "KZT",
            'MDL': "MDL",
            'MXN': "MXN",
            'MYR': "MYR",
            'NAD': "NAD",
            'NOK': "NOK",
            'NZD': "NZD",
            'OMR': "OMR",
            'PLN': "PLN",
            'QAR': "QAR",
            'RON': "RON",
            'RUB': "RUB",
            'SAR': "SAR",
            'SEK': "SEK",
            'SGD': "SGD",
            'THB': "THB",
            'TRY': "TRY",
            'TWD': "TWD",
            'UAH': "UAH",
            'USD': "USD",
            'XOF': "XOF",
            'ZAR': "ZAR",
        },
        ('language_code',): {
            'AF': "af",
            'AR': "ar",
            'BG': "bg",
            'CA': "ca",
            'CS': "cs",
            'DA': "da",
            'DE': "de",
            'EL': "el",
            'EN': "en",
            'ES': "es",
            'ET': "et",
            'FI': "fi",
            'FR': "fr",
            'HE': "he",
            'HI': "hi",
            'HR': "hr",
            'HU': "hu",
            'ID': "id",
            'IS': "is",
            'IT': "it",
            'JA': "ja",
            'KO': "ko",
            'LT': "lt",
            'LV': "lv",
            'NL': "nl",
            'NO': "no",
            'PL': "pl",
            'PT': "pt",
            'RO': "ro",
            'RU': "ru",
            'SK': "sk",
            'SL': "sl",
            'SR': "sr",
            'SV': "sv",
            'TH': "th",
            'TR': "tr",
            'VI': "vi",
            'ZH': "zh",
        },
        ('unit_system',): {
            'METRIC': "metric",
            'IMPERIAL': "imperial",
        },
        ('location_type',): {
            'FORMATTED_ADDRESS': "formatted_address",
            'PLACE_ID': "place_id",
            'LOCALITY': "locality",
            'ADMINISTRATIVE_AREA_LEVEL_1': "administrative_area_level_1",
            'ADMINISTRATIVE_AREA_LEVEL_2': "administrative_area_level_2",
            'ADMINISTRATIVE_AREA_LEVEL_3': "administrative_area_level_3",
            'ADMINISTRATIVE_AREA_LEVEL_4': "administrative_area_level_4",
            'ADMINISTRATIVE_AREA_LEVEL_5': "administrative_area_level_5",
            'STATE_CODE': "state_code",
            'COUNTRY': "country",
            'COUNTRY_CODE': "country_code",
            'POSTAL_CODE': "postal_code",
            'LANGUAGE': "language",
            'NATURAL_FEATURE': "natural_feature",
            'ESTABLISHMENT': "establishment",
            'SUBLOCALITY': "sublocality",
            'SUBLOCALITY_LEVEL_1': "sublocality_level_1",
            'SUBLOCALITY_LEVEL_2': "sublocality_level_2",
            'SUBLOCALITY_LEVEL_3': "sublocality_level_3",
            'SUBLOCALITY_LEVEL_4': "sublocality_level_4",
            'SUBLOCALITY_LEVEL_5': "sublocality_level_5",
            'STREETNUMBER': "streetNumber",
        },
        ('sort',): {
            'QUALITY': "quality",
            'PRICE': "price",
        },
        ('service_list',): {
            '1': 1,
            '2': 2,
            '3': 3,
            '4': 4,
            '5': 5,
            '6': 6,
            '7': 7,
            '8': 8,
            '9': 9,
            '10': 10,
            '11': 11,
            '12': 12,
            '13': 13,
            '14': 14,
            '15': 15,
            '16': 16,
            '17': 17,
            '18': 18,
            '19': 19,
            '20': 20,
            '21': 21,
            '22': 22,
            '23': 23,
            '24': 24,
            '25': 25,
            '26': 26,
            '27': 27,
            '28': 28,
            '29': 29,
            '30': 30,
            '31': 31,
            '32': 32,
            '33': 33,
            '34': 34,
            '35': 35,
            '36': 36,
            '37': 37,
            '38': 38,
            '39': 39,
            '40': 40,
            '41': 41,
            '42': 42,
            '43': 43,
            '44': 44,
            '45': 45,
            '46': 46,
            '47': 47,
            '48': 48,
            '49': 49,
            '50': 50,
            '51': 51,
            '52': 52,
            '53': 53,
            '54': 54,
            '55': 55,
            '56': 56,
            '57': 57,
            '58': 58,
            '59': 59,
            '60': 60,
            '61': 61,
            '62': 62,
            '63': 63,
            '64': 64,
            '65': 65,
            '66': 66,
            '67': 67,
            '68': 68,
            '69': 69,
            '70': 70,
            '71': 71,
            '72': 72,
            '73': 73,
            '74': 74,
            '75': 75,
            '76': 76,
            '77': 77,
            '78': 78,
            '79': 79,
            '80': 80,
            '81': 81,
            '82': 82,
            '83': 83,
            '84': 84,
            '85': 85,
            '86': 86,
            '87': 87,
            '88': 88,
            '89': 89,
            '90': 90,
            '91': 91,
            '92': 92,
            '93': 93,
            '94': 94,
            '95': 95,
            '96': 96,
            '97': 97,
            '98': 98,
            '99': 99,
            '100': 100,
            '101': 101,
            '102': 102,
            '103': 103,
            '104': 104,
            '105': 105,
            '106': 106,
            '107': 107,
            '108': 108,
            '109': 109,
            '110': 110,
            '111': 111,
            '112': 112,
            '113': 113,
            '114': 114,
            '115': 115,
            '116': 116,
            '117': 117,
            '118': 118,
            '119': 119,
            '120': 120,
            '121': 121,
            '122': 122,
            '123': 123,
            '124': 124,
            '125': 125,
            '126': 126,
            '127': 127,
            '128': 128,
            '129': 129,
            '130': 130,
            '131': 131,
            '132': 132,
            '133': 133,
            '134': 134,
            '135': 135,
            '136': 136,
            '137': 137,
            '138': 138,
            '139': 139,
            '140': 140,
            '141': 141,
            '142': 142,
            '143': 143,
            '144': 144,
            '145': 145,
            '146': 146,
            '147': 147,
            '148': 148,
            '149': 149,
            '150': 150,
            '151': 151,
            '152': 152,
            '153': 153,
            '154': 154,
            '155': 155,
            '156': 156,
            '157': 157,
            '158': 158,
            '159': 159,
            '160': 160,
            '161': 161,
            '162': 162,
            '163': 163,
            '164': 164,
            '165': 165,
            '166': 166,
            '167': 167,
            '168': 168,
            '169': 169,
            '170': 170,
            '171': 171,
            '172': 172,
            '173': 173,
            '174': 174,
            '175': 175,
            '176': 176,
            '177': 177,
            '178': 178,
            '179': 179,
            '180': 180,
            '181': 181,
            '182': 182,
            '183': 183,
            '184': 184,
            '185': 185,
            '186': 186,
            '187': 187,
            '188': 188,
            '189': 189,
            '190': 190,
            '191': 191,
            '192': 192,
            '193': 193,
            '194': 194,
            '195': 195,
            '196': 196,
            '197': 197,
            '198': 198,
            '199': 199,
            '200': 200,
            '201': 201,
            '202': 202,
            '203': 203,
            '204': 204,
            '205': 205,
            '206': 206,
            '207': 207,
            '208': 208,
            '209': 209,
            '210': 210,
            '211': 211,
            '212': 212,
            '213': 213,
            '214': 214,
            '215': 215,
            '216': 216,
            '217': 217,
            '218': 218,
            '219': 219,
            '220': 220,
            '221': 221,
            '222': 222,
            '223': 223,
            '224': 224,
            '225': 225,
            '226': 226,
            '227': 227,
            '228': 228,
            '229': 229,
            '230': 230,
            '231': 231,
            '232': 232,
            '233': 233,
            '234': 234,
            '235': 235,
            '236': 236,
            '237': 237,
            '238': 238,
            '239': 239,
            '240': 240,
            '241': 241,
            '242': 242,
            '243': 243,
            '244': 244,
            '245': 245,
            '246': 246,
            '247': 247,
            '248': 248,
            '249': 249,
            '250': 250,
            '251': 251,
            '252': 252,
            '253': 253,
            '254': 254,
            '255': 255,
            '256': 256,
            '257': 257,
            '258': 258,
            '259': 259,
            '260': 260,
            '261': 261,
            '262': 262,
            '263': 263,
            '264': 264,
            '265': 265,
            '266': 266,
            '267': 267,
            '268': 268,
            '269': 269,
            '270': 270,
            '271': 271,
            '272': 272,
            '273': 273,
            '274': 274,
            '275': 275,
            '276': 276,
            '277': 277,
            '278': 278,
            '279': 279,
            '280': 280,
            '281': 281,
            '282': 282,
            '283': 283,
            '284': 284,
            '285': 285,
            '286': 286,
            '287': 287,
            '288': 288,
            '289': 289,
            '290': 290,
            '291': 291,
            '292': 292,
            '293': 293,
            '294': 294,
            '295': 295,
            '296': 296,
            '297': 297,
            '298': 298,
            '299': 299,
            '300': 300,
            '301': 301,
            '302': 302,
            '303': 303,
            '304': 304,
            '305': 305,
            '306': 306,
            '307': 307,
            '308': 308,
            '309': 309,
            '310': 310,
            '311': 311,
            '312': 312,
            '313': 313,
            '314': 314,
            '315': 315,
            '316': 316,
            '317': 317,
            '318': 318,
            '319': 319,
            '320': 320,
            '321': 321,
            '322': 322,
            '323': 323,
            '324': 324,
            '325': 325,
            '326': 326,
            '327': 327,
            '328': 328,
            '329': 329,
            '331': 331,
            '332': 332,
            '333': 333,
            '334': 334,
            '335': 335,
            '336': 336,
            '337': 337,
            '338': 338,
            '339': 339,
            '340': 340,
            '341': 341,
            '342': 342,
            '343': 343,
            '344': 344,
            '345': 345,
            '348': 348,
            '349': 349,
            '350': 350,
            '351': 351,
            '5000': 5000,
            '5001': 5001,
            '5002': 5002,
            '5003': 5003,
            '5004': 5004,
            '5005': 5005,
            '5006': 5006,
            '5007': 5007,
            '5008': 5008,
            '5009': 5009,
            '5010': 5010,
            '5011': 5011,
            '5012': 5012,
            '5013': 5013,
            '5014': 5014,
            '5015': 5015,
            '5016': 5016,
            '5017': 5017,
            '5018': 5018,
            '5020': 5020,
            '5021': 5021,
            '5022': 5022,
            '5023': 5023,
            '5024': 5024,
            '5025': 5025,
            '5026': 5026,
            '5027': 5027,
            '5028': 5028,
            '5029': 5029,
            '5030': 5030,
            '5031': 5031,
            '5032': 5032,
            '5033': 5033,
            '5034': 5034,
            '5035': 5035,
            '5036': 5036,
            '5037': 5037,
            '5039': 5039,
            '5040': 5040,
            '5041': 5041,
            '5042': 5042,
            '5043': 5043,
            '5044': 5044,
            '5045': 5045,
            '5046': 5046,
            '5047': 5047,
            '5048': 5048,
            '5049': 5049,
            '5050': 5050,
            '5051': 5051,
            '5052': 5052,
            '5053': 5053,
            '5054': 5054,
            '5055': 5055,
            '5056': 5056,
            '5057': 5057,
            '5058': 5058,
            '5059': 5059,
            '5060': 5060,
            '5061': 5061,
            '5062': 5062,
            '5063': 5063,
            '5064': 5064,
            '5065': 5065,
            '5066': 5066,
            '5067': 5067,
            '5068': 5068,
            '5069': 5069,
            '5070': 5070,
            '5071': 5071,
            '5072': 5072,
            '5073': 5073,
            '5074': 5074,
            '5075': 5075,
            '5076': 5076,
            '5077': 5077,
            '5078': 5078,
            '5079': 5079,
            '5080': 5080,
            '5081': 5081,
            '5082': 5082,
            '5083': 5083,
            '5084': 5084,
            '5085': 5085,
            '5086': 5086,
            '5087': 5087,
            '5088': 5088,
            '5089': 5089,
            '5090': 5090,
            '5091': 5091,
            '5092': 5092,
            '5093': 5093,
            '5094': 5094,
            '5095': 5095,
            '5096': 5096,
            '5097': 5097,
            '5098': 5098,
            '5099': 5099,
            '5100': 5100,
            '5101': 5101,
            '5102': 5102,
            '5103': 5103,
            '5104': 5104,
            '5105': 5105,
            '5106': 5106,
            '5107': 5107,
            '5108': 5108,
            '5109': 5109,
            '5110': 5110,
            '5111': 5111,
            '5112': 5112,
            '5113': 5113,
            '5114': 5114,
            '5115': 5115,
            '5116': 5116,
            '5117': 5117,
            '5118': 5118,
            '5119': 5119,
            '5120': 5120,
            '5121': 5121,
            '5122': 5122,
            '5123': 5123,
            '5124': 5124,
            '5125': 5125,
            '5126': 5126,
            '5127': 5127,
            '5128': 5128,
            '5129': 5129,
            '5130': 5130,
            '5131': 5131,
            '5132': 5132,
            '5133': 5133,
            '5134': 5134,
            '5135': 5135,
            '5136': 5136,
            '5137': 5137,
            '5138': 5138,
            '5139': 5139,
            '5140': 5140,
            '5141': 5141,
            '5142': 5142,
            '5143': 5143,
            '5144': 5144,
            '5145': 5145,
            '5146': 5146,
            '5147': 5147,
            '5148': 5148,
            '5149': 5149,
            '5150': 5150,
            '5151': 5151,
            '5152': 5152,
            '5153': 5153,
            '5154': 5154,
            '5156': 5156,
            '5157': 5157,
            '5158': 5158,
            '5159': 5159,
            '5160': 5160,
            '5161': 5161,
            '5162': 5162,
            '5163': 5163,
            '5164': 5164,
            '5165': 5165,
            '5166': 5166,
            '5167': 5167,
            '5168': 5168,
            '5169': 5169,
            '5170': 5170,
            '5171': 5171,
            '5172': 5172,
            '5173': 5173,
            '5174': 5174,
            '5175': 5175,
            '5176': 5176,
            '5177': 5177,
            '5178': 5178,
            '6000': 6000,
            '6001': 6001,
            '90001': 90001,
        },
        ('type_list',): {
            '1': 1,
            '2': 2,
            '3': 3,
            '4': 4,
            '5': 5,
            '6': 6,
            '7': 7,
            '8': 8,
            '9': 9,
            '10': 10,
            '11': 11,
            '12': 12,
            '13': 13,
            '14': 14,
            '15': 15,
            '16': 16,
            '17': 17,
            '18': 18,
            '19': 19,
            '20': 20,
            '21': 21,
            '22': 22,
            '23': 23,
            '24': 24,
            '25': 25,
            '26': 26,
            '27': 27,
            '28': 28,
            '29': 29,
            '30': 30,
            '31': 31,
            '32': 32,
            '33': 33,
            '34': 34,
            '35': 35,
            '36': 36,
            '37': 37,
            '38': 38,
            '39': 39,
            '40': 40,
            '41': 41,
            '42': 42,
            '43': 43,
            '44': 44,
            '45': 45,
            '46': 46,
            '47': 47,
            '48': 48,
            '49': 49,
            '50': 50,
            '51': 51,
            '52': 52,
            '53': 53,
            '54': 54,
            '55': 55,
            '56': 56,
            '57': 57,
            '58': 58,
            '59': 59,
            '60': 60,
            '61': 61,
            '62': 62,
            '5000': 5000,
            '5001': 5001,
            '5002': 5002,
            '5003': 5003,
            '5004': 5004,
            '5005': 5005,
            '5006': 5006,
            '5007': 5007,
            '5008': 5008,
            '5009': 5009,
        },
        ('unit_type_list',): {
            '1': 1,
            '4': 4,
            '5': 5,
            '7': 7,
            '8': 8,
            '9': 9,
            '10': 10,
            '12': 12,
            '13': 13,
            '24': 24,
            '25': 25,
            '26': 26,
            '27': 27,
            '28': 28,
            '29': 29,
            '31': 31,
            '32': 32,
            '33': 33,
        },
        ('unit_amenity_list',): {
            '1': 1,
            '2': 2,
            '3': 3,
            '4': 4,
            '5': 5,
            '6': 6,
            '7': 7,
            '8': 8,
            '9': 9,
            '10': 10,
            '11': 11,
            '12': 12,
            '13': 13,
            '14': 14,
            '15': 15,
            '16': 16,
            '17': 17,
            '18': 18,
            '19': 19,
            '20': 20,
            '21': 21,
            '22': 22,
            '23': 23,
            '24': 24,
            '25': 25,
            '26': 26,
            '27': 27,
            '28': 28,
            '29': 29,
            '30': 30,
            '31': 31,
            '32': 32,
            '33': 33,
            '34': 34,
            '35': 35,
            '36': 36,
            '37': 37,
            '38': 38,
            '39': 39,
            '40': 40,
            '41': 41,
            '42': 42,
            '43': 43,
            '44': 44,
            '45': 45,
            '46': 46,
            '47': 47,
            '48': 48,
            '49': 49,
            '50': 50,
            '51': 51,
            '52': 52,
            '53': 53,
            '54': 54,
            '55': 55,
            '56': 56,
            '57': 57,
            '58': 58,
            '59': 59,
            '60': 60,
            '61': 61,
            '62': 62,
            '63': 63,
            '64': 64,
            '65': 65,
            '66': 66,
            '67': 67,
            '68': 68,
            '69': 69,
            '70': 70,
            '71': 71,
            '72': 72,
            '73': 73,
            '74': 74,
            '75': 75,
            '76': 76,
            '77': 77,
            '78': 78,
            '79': 79,
            '80': 80,
            '81': 81,
            '82': 82,
            '83': 83,
            '84': 84,
            '85': 85,
            '86': 86,
            '87': 87,
            '88': 88,
            '89': 89,
            '90': 90,
            '91': 91,
            '92': 92,
            '93': 93,
            '94': 94,
            '95': 95,
            '96': 96,
            '97': 97,
            '98': 98,
            '99': 99,
            '100': 100,
            '101': 101,
            '102': 102,
            '103': 103,
            '104': 104,
            '105': 105,
            '106': 106,
            '107': 107,
            '108': 108,
            '109': 109,
            '110': 110,
            '111': 111,
            '112': 112,
            '113': 113,
            '114': 114,
            '115': 115,
            '116': 116,
            '117': 117,
            '118': 118,
            '119': 119,
            '120': 120,
            '121': 121,
            '122': 122,
            '123': 123,
            '124': 124,
            '125': 125,
            '126': 126,
            '127': 127,
            '128': 128,
            '129': 129,
            '130': 130,
            '131': 131,
            '132': 132,
            '133': 133,
            '134': 134,
            '135': 135,
            '136': 136,
            '137': 137,
            '138': 138,
            '139': 139,
            '140': 140,
            '141': 141,
            '142': 142,
            '143': 143,
            '144': 144,
            '145': 145,
            '146': 146,
            '147': 147,
            '148': 148,
            '149': 149,
            '150': 150,
            '151': 151,
            '152': 152,
            '153': 153,
            '154': 154,
            '155': 155,
            '156': 156,
            '157': 157,
            '158': 158,
            '159': 159,
            '160': 160,
            '161': 161,
            '162': 162,
            '163': 163,
            '164': 164,
            '165': 165,
            '166': 166,
            '167': 167,
            '168': 168,
            '169': 169,
            '170': 170,
            '171': 171,
            '172': 172,
            '173': 173,
            '174': 174,
            '175': 175,
            '176': 176,
            '177': 177,
            '178': 178,
            '179': 179,
            '180': 180,
            '181': 181,
            '182': 182,
            '183': 183,
            '184': 184,
            '185': 185,
            '186': 186,
            '187': 187,
            '188': 188,
            '189': 189,
            '190': 190,
            '191': 191,
            '192': 192,
            '193': 193,
            '194': 194,
            '195': 195,
            '196': 196,
            '197': 197,
            '198': 198,
            '199': 199,
            '200': 200,
            '201': 201,
            '202': 202,
            '203': 203,
            '204': 204,
            '205': 205,
            '206': 206,
            '207': 207,
            '208': 208,
            '209': 209,
            '210': 210,
            '211': 211,
            '212': 212,
            '213': 213,
            '214': 214,
            '215': 215,
            '216': 216,
            '217': 217,
            '218': 218,
            '219': 219,
            '220': 220,
            '221': 221,
            '222': 222,
            '223': 223,
            '224': 224,
            '225': 225,
            '226': 226,
            '227': 227,
            '228': 228,
            '229': 229,
            '230': 230,
            '231': 231,
            '232': 232,
            '233': 233,
            '234': 234,
            '235': 235,
            '236': 236,
            '237': 237,
            '238': 238,
            '239': 239,
            '240': 240,
            '241': 241,
            '242': 242,
            '243': 243,
            '244': 244,
            '245': 245,
            '246': 246,
            '247': 247,
            '248': 248,
            '249': 249,
            '250': 250,
            '251': 251,
            '252': 252,
            '253': 253,
            '254': 254,
            '255': 255,
            '256': 256,
            '257': 257,
            '258': 258,
            '259': 259,
            '260': 260,
            '261': 261,
            '262': 262,
            '263': 263,
            '264': 264,
            '265': 265,
            '266': 266,
            '267': 267,
            '268': 268,
            '269': 269,
            '270': 270,
            '271': 271,
            '272': 272,
            '273': 273,
            '274': 274,
            '275': 275,
            '276': 276,
            '277': 277,
            '278': 278,
            '279': 279,
            '280': 280,
            '281': 281,
            '282': 282,
            '283': 283,
            '5001': 5001,
            '5002': 5002,
            '5003': 5003,
            '5004': 5004,
            '5005': 5005,
            '5006': 5006,
            '5007': 5007,
            '5008': 5008,
            '5009': 5009,
            '5010': 5010,
            '5011': 5011,
            '5012': 5012,
            '5013': 5013,
            '5014': 5014,
            '5015': 5015,
            '5016': 5016,
            '5017': 5017,
            '5018': 5018,
            '5019': 5019,
            '5020': 5020,
            '5021': 5021,
            '5022': 5022,
            '5023': 5023,
            '5024': 5024,
            '5025': 5025,
            '5026': 5026,
            '5027': 5027,
            '5028': 5028,
            '5029': 5029,
            '5030': 5030,
            '5031': 5031,
            '5032': 5032,
            '5033': 5033,
            '5034': 5034,
            '5035': 5035,
            '5036': 5036,
            '5037': 5037,
            '5038': 5038,
            '5039': 5039,
            '5040': 5040,
            '5041': 5041,
            '5042': 5042,
            '5043': 5043,
            '5044': 5044,
            '5045': 5045,
            '5046': 5046,
            '5068': 5068,
            '5069': 5069,
            '5070': 5070,
            '5071': 5071,
            '5072': 5072,
            '5073': 5073,
            '5074': 5074,
            '5075': 5075,
            '5076': 5076,
            '5077': 5077,
            '5079': 5079,
            '5080': 5080,
            '5081': 5081,
            '5082': 5082,
            '5083': 5083,
            '5084': 5084,
            '5085': 5085,
            '5086': 5086,
            '5087': 5087,
            '5088': 5088,
            '5089': 5089,
            '5090': 5090,
            '5091': 5091,
            '5092': 5092,
            '5093': 5093,
            '5094': 5094,
            '5095': 5095,
            '5096': 5096,
            '5097': 5097,
            '5098': 5098,
            '5099': 5099,
            '5100': 5100,
            '5101': 5101,
            '5102': 5102,
            '5103': 5103,
            '5104': 5104,
            '5105': 5105,
            '5106': 5106,
            '5107': 5107,
            '5108': 5108,
            '5109': 5109,
            '5110': 5110,
            '5111': 5111,
            '5112': 5112,
            '5113': 5113,
            '5114': 5114,
            '5115': 5115,
            '5116': 5116,
            '5117': 5117,
            '5118': 5118,
            '5119': 5119,
            '5120': 5120,
            '5121': 5121,
            '5122': 5122,
            '5123': 5123,
            '5124': 5124,
            '5125': 5125,
            '5126': 5126,
            '5127': 5127,
            '5129': 5129,
            '5130': 5130,
            '5131': 5131,
            '5132': 5132,
            '5133': 5133,
            '5134': 5134,
            '5135': 5135,
            '5136': 5136,
            '5137': 5137,
            '5138': 5138,
            '5139': 5139,
            '5140': 5140,
            '5141': 5141,
            '5142': 5142,
            '5143': 5143,
            '5144': 5144,
            '5145': 5145,
            '5146': 5146,
            '5147': 5147,
            '5148': 5148,
            '5149': 5149,
            '5150': 5150,
            '5151': 5151,
            '5152': 5152,
            '5153': 5153,
            '5154': 5154,
            '5157': 5157,
            '5158': 5158,
            '5159': 5159,
            '5160': 5160,
            '5161': 5161,
            '5162': 5162,
            '5163': 5163,
            '5164': 5164,
            '5165': 5165,
            '5166': 5166,
            '5167': 5167,
            '5168': 5168,
            '5169': 5169,
            '5170': 5170,
            '5171': 5171,
            '5172': 5172,
            '5173': 5173,
            '5174': 5174,
            '5175': 5175,
            '5176': 5176,
            '5177': 5177,
            '5178': 5178,
            '5179': 5179,
            '5180': 5180,
            '5181': 5181,
            '5182': 5182,
            '5184': 5184,
            '5185': 5185,
            '5186': 5186,
            '5187': 5187,
            '5188': 5188,
            '5189': 5189,
            '5190': 5190,
            '5191': 5191,
            '5196': 5196,
            '5198': 5198,
            '5199': 5199,
            '5200': 5200,
            '5201': 5201,
            '5202': 5202,
            '5203': 5203,
            '5204': 5204,
            '5205': 5205,
            '5206': 5206,
            '5207': 5207,
            '5211': 5211,
            '5212': 5212,
            '90001': 90001,
            '90002': 90002,
            '90003': 90003,
            '90004': 90004,
            '90005': 90005,
            '90006': 90006,
            '90007': 90007,
            '90008': 90008,
            '90009': 90009,
            '90010': 90010,
            '90011': 90011,
        },
        ('meal_plan_list',): {
            '0': 0,
            '1': 1,
            '2': 2,
            '3': 3,
            '4': 4,
            '5': 5,
            '6': 6,
            '7': 7,
            '8': 8,
            '9': 9,
            '10': 10,
            '11': 11,
            '12': 12,
            '14': 14,
            '15': 15,
            '16': 16,
            '17': 17,
            '18': 18,
            '19': 19,
            '20': 20,
            '21': 21,
            '22': 22,
            '23': 23,
            '24': 24,
            '90001': 90001,
        },
    }

    validations = {
        ('adult_count',): {
            'inclusive_minimum': 1,
        },
        ('child_count',): {
            'inclusive_minimum': 0,
        },
        ('min_length_of_stay',): {
            'inclusive_maximum': 30,
            'inclusive_minimum': 1,
        },
        ('max_length_of_stay',): {
            'inclusive_maximum': 30,
            'inclusive_minimum': 1,
        },
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'currency_code': (str,),  # noqa: E501
            'language_code': (str,),  # noqa: E501
            'adult_count': (int,),  # noqa: E501
            'child_count': (int,),  # noqa: E501
            'child_age_list': ([int],),  # noqa: E501
            'unit_system': (str,),  # noqa: E501
            'min_length_of_stay': (int,),  # noqa: E501
            'max_length_of_stay': (int,),  # noqa: E501
            'location_name': (str,),  # noqa: E501
            'location_type': (str,),  # noqa: E501
            'earliest_arrival': (str,),  # noqa: E501
            'latest_return': (str,),  # noqa: E501
            'sort': (str,),  # noqa: E501
            'service_list': ([float],),  # noqa: E501
            'type_list': ([float],),  # noqa: E501
            'unit_type_list': ([float],),  # noqa: E501
            'unit_amenity_list': ([float],),  # noqa: E501
            'meal_plan_list': ([float],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'currency_code': 'currencyCode',  # noqa: E501
        'language_code': 'languageCode',  # noqa: E501
        'adult_count': 'adultCount',  # noqa: E501
        'child_count': 'childCount',  # noqa: E501
        'child_age_list': 'childAgeList',  # noqa: E501
        'unit_system': 'unitSystem',  # noqa: E501
        'min_length_of_stay': 'minLengthOfStay',  # noqa: E501
        'max_length_of_stay': 'maxLengthOfStay',  # noqa: E501
        'location_name': 'locationName',  # noqa: E501
        'location_type': 'locationType',  # noqa: E501
        'earliest_arrival': 'earliestArrival',  # noqa: E501
        'latest_return': 'latestReturn',  # noqa: E501
        'sort': 'sort',  # noqa: E501
        'service_list': 'serviceList',  # noqa: E501
        'type_list': 'typeList',  # noqa: E501
        'unit_type_list': 'unitTypeList',  # noqa: E501
        'unit_amenity_list': 'unitAmenityList',  # noqa: E501
        'meal_plan_list': 'mealPlanList',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, currency_code, language_code, *args, **kwargs):  # noqa: E501
        """AvailabilitySearchPostRequest - a model defined in OpenAPI

        Args:
            currency_code (str): The currency code of the currency in which the lowest price for each found location should be returned.<p>See also <a href=\"#currencycodes\">in the appendix</a>.</p>
            language_code (str): The language code of the language in which the descriptive texts for each found property should be returned.<p>Please note that beside the general restrictions listed below only languages configured during system setup for your respective tenant are allowed.</p><p>See also <a href=\"#isolanguage-codes\">in the appendix</a>.</p>

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            adult_count (int): The amount of adults that will stay at the property.. [optional] if omitted the server will use the default value of 2  # noqa: E501
            child_count (int): The amount of children that will stay at the property.. [optional]  # noqa: E501
            child_age_list ([int]): A list describing the ages of the children that will stay at the property. If <code>childAgeList</code> is set <code>childCount</code> has to be set as well. If <code>childAgeList</code> and <code>childCount</code> are set, <code>childCount</code> must be equal to the length of <code>childAgeList</code>.. [optional]  # noqa: E501
            unit_system (str): The unit system to use in the result.. [optional] if omitted the server will use the default value of "metric"  # noqa: E501
            min_length_of_stay (int): The desired minimum length of stay in nights.. [optional]  # noqa: E501
            max_length_of_stay (int): The desired maximum length of stay in nights.. [optional]  # noqa: E501
            location_name (str): The name of a location the properties should be located in.If <code>locationType</code> is set, <code>locationName</code> has to bet set as well.. [optional]  # noqa: E501
            location_type (str): Defines the type of<code>locationName</code>. If <code>locationType</code> is set, <code>locationName</code> has to bet set as well.<p>See also <a href=\"#locationtypes\">in the appendix</a>.</p>. [optional]  # noqa: E501
            earliest_arrival (str): The earliest possible arrival date. Expects exactly the format of \"YYYY-MM-DD\".. [optional]  # noqa: E501
            latest_return (str): The latest possible departure date. Expects exactly the format of \"YYYY-MM-DD\".. [optional]  # noqa: E501
            sort (str): The criteria to order the results by. Sort order for price is ascending, sort order for quality is always descending. Quality is an internally calculated score for the property.',           )}. [optional]  # noqa: E501
            service_list ([float]): A list of service codes indicating which services and amenities the entire property should offer. The codes are AND chained.<p>See also <a href=\"#servicecodes\">in the appendix</a>.</p>. [optional]  # noqa: E501
            type_list ([float]): A list of property class type codes specifying the desired property classes. The codes are OR chained.<p>See also <a href=\"#propertyclass-type-codes\">in the appendix</a>.</p>. [optional]  # noqa: E501
            unit_type_list ([float]): A list of unit and room type codes indicating which kinds of unit/room type is desired.<p>See also <a href=\"#unitand-room-type-codes\">in the appendix</a>.</p>. [optional]  # noqa: E501
            unit_amenity_list ([float]): A list of room amenity type codes indicating which room level amenities are desired. The codes are AND chained.<p>See also <a href=\"#unitand-room-amenity-type-codes\">in the appendix</a>.</p>. [optional]  # noqa: E501
            meal_plan_list ([float]): A list of meal plan type codes indicating which kinds of meal plan type is desired.<p>See also <a href=\"#mealplan-type-codes\">in the appendix</a>.</p>. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.currency_code = currency_code
        self.language_code = language_code
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, currency_code, language_code, *args, **kwargs):  # noqa: E501
        """AvailabilitySearchPostRequest - a model defined in OpenAPI

        Args:
            currency_code (str): The currency code of the currency in which the lowest price for each found location should be returned.<p>See also <a href=\"#currencycodes\">in the appendix</a>.</p>
            language_code (str): The language code of the language in which the descriptive texts for each found property should be returned.<p>Please note that beside the general restrictions listed below only languages configured during system setup for your respective tenant are allowed.</p><p>See also <a href=\"#isolanguage-codes\">in the appendix</a>.</p>

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            adult_count (int): The amount of adults that will stay at the property.. [optional] if omitted the server will use the default value of 2  # noqa: E501
            child_count (int): The amount of children that will stay at the property.. [optional]  # noqa: E501
            child_age_list ([int]): A list describing the ages of the children that will stay at the property. If <code>childAgeList</code> is set <code>childCount</code> has to be set as well. If <code>childAgeList</code> and <code>childCount</code> are set, <code>childCount</code> must be equal to the length of <code>childAgeList</code>.. [optional]  # noqa: E501
            unit_system (str): The unit system to use in the result.. [optional] if omitted the server will use the default value of "metric"  # noqa: E501
            min_length_of_stay (int): The desired minimum length of stay in nights.. [optional]  # noqa: E501
            max_length_of_stay (int): The desired maximum length of stay in nights.. [optional]  # noqa: E501
            location_name (str): The name of a location the properties should be located in.If <code>locationType</code> is set, <code>locationName</code> has to bet set as well.. [optional]  # noqa: E501
            location_type (str): Defines the type of<code>locationName</code>. If <code>locationType</code> is set, <code>locationName</code> has to bet set as well.<p>See also <a href=\"#locationtypes\">in the appendix</a>.</p>. [optional]  # noqa: E501
            earliest_arrival (str): The earliest possible arrival date. Expects exactly the format of \"YYYY-MM-DD\".. [optional]  # noqa: E501
            latest_return (str): The latest possible departure date. Expects exactly the format of \"YYYY-MM-DD\".. [optional]  # noqa: E501
            sort (str): The criteria to order the results by. Sort order for price is ascending, sort order for quality is always descending. Quality is an internally calculated score for the property.',           )}. [optional]  # noqa: E501
            service_list ([float]): A list of service codes indicating which services and amenities the entire property should offer. The codes are AND chained.<p>See also <a href=\"#servicecodes\">in the appendix</a>.</p>. [optional]  # noqa: E501
            type_list ([float]): A list of property class type codes specifying the desired property classes. The codes are OR chained.<p>See also <a href=\"#propertyclass-type-codes\">in the appendix</a>.</p>. [optional]  # noqa: E501
            unit_type_list ([float]): A list of unit and room type codes indicating which kinds of unit/room type is desired.<p>See also <a href=\"#unitand-room-type-codes\">in the appendix</a>.</p>. [optional]  # noqa: E501
            unit_amenity_list ([float]): A list of room amenity type codes indicating which room level amenities are desired. The codes are AND chained.<p>See also <a href=\"#unitand-room-amenity-type-codes\">in the appendix</a>.</p>. [optional]  # noqa: E501
            meal_plan_list ([float]): A list of meal plan type codes indicating which kinds of meal plan type is desired.<p>See also <a href=\"#mealplan-type-codes\">in the appendix</a>.</p>. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.currency_code = currency_code
        self.language_code = language_code
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
