"""
    lodgea-python

    LODGEA SDK for Python. Check out https://docs.lodgea.io for more information.  # noqa: E501

    The version of the OpenAPI document: 1.1.0
    Contact: support@lodgea.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from lodgea-python.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from lodgea-python.exceptions import ApiAttributeError


def lazy_import():
    from lodgea-python.model.properties_property_id_get200_response_product_list_inner_policy_info import PropertiesPropertyIdGet200ResponseProductListInnerPolicyInfo
    from lodgea-python.model.properties_property_id_get200_response_product_list_inner_rate_plan_list_inner import PropertiesPropertyIdGet200ResponseProductListInnerRatePlanListInner
    globals()['PropertiesPropertyIdGet200ResponseProductListInnerPolicyInfo'] = PropertiesPropertyIdGet200ResponseProductListInnerPolicyInfo
    globals()['PropertiesPropertyIdGet200ResponseProductListInnerRatePlanListInner'] = PropertiesPropertyIdGet200ResponseProductListInnerRatePlanListInner


class PropertiesPropertyIdGet200ResponseProductListInner(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('meal_plan_list',): {
            '0': 0,
            '1': 1,
            '2': 2,
            '3': 3,
            '4': 4,
            '5': 5,
            '6': 6,
            '7': 7,
            '8': 8,
            '9': 9,
            '10': 10,
            '11': 11,
            '12': 12,
            '14': 14,
            '15': 15,
            '16': 16,
            '17': 17,
            '18': 18,
            '19': 19,
            '20': 20,
            '21': 21,
            '22': 22,
            '23': 23,
            '24': 24,
            '90001': 90001,
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'property_id': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'meal_plan_list': ([float],),  # noqa: E501
            'room_type_list': ([str],),  # noqa: E501
            'rate_plan_list': ([PropertiesPropertyIdGet200ResponseProductListInnerRatePlanListInner],),  # noqa: E501
            'is_los_pricing': (bool,),  # noqa: E501
            'is_obp_pricing': (bool,),  # noqa: E501
            'policy_info': (PropertiesPropertyIdGet200ResponseProductListInnerPolicyInfo,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'property_id': 'propertyId',  # noqa: E501
        'name': 'name',  # noqa: E501
        'meal_plan_list': 'mealPlanList',  # noqa: E501
        'room_type_list': 'roomTypeList',  # noqa: E501
        'rate_plan_list': 'ratePlanList',  # noqa: E501
        'is_los_pricing': 'isLOSPricing',  # noqa: E501
        'is_obp_pricing': 'isOBPPricing',  # noqa: E501
        'policy_info': 'policyInfo',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, property_id, name, meal_plan_list, room_type_list, rate_plan_list, *args, **kwargs):  # noqa: E501
        """PropertiesPropertyIdGet200ResponseProductListInner - a model defined in OpenAPI

        Args:
            property_id (str): The ID of the property.
            name (str): The name of the product.
            meal_plan_list ([float]): A list of meal type codes included in this product.
            room_type_list ([str]): An array of strings describing the room types included in this product.
            rate_plan_list ([PropertiesPropertyIdGet200ResponseProductListInnerRatePlanListInner]): The rate plans for this product.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            is_los_pricing (bool): Whether this product is length of stay pricing.. [optional]  # noqa: E501
            is_obp_pricing (bool): Whether this product is occupancy based pricing.. [optional]  # noqa: E501
            policy_info (PropertiesPropertyIdGet200ResponseProductListInnerPolicyInfo): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.property_id = property_id
        self.name = name
        self.meal_plan_list = meal_plan_list
        self.room_type_list = room_type_list
        self.rate_plan_list = rate_plan_list
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, property_id, name, meal_plan_list, room_type_list, rate_plan_list, *args, **kwargs):  # noqa: E501
        """PropertiesPropertyIdGet200ResponseProductListInner - a model defined in OpenAPI

        Args:
            property_id (str): The ID of the property.
            name (str): The name of the product.
            meal_plan_list ([float]): A list of meal type codes included in this product.
            room_type_list ([str]): An array of strings describing the room types included in this product.
            rate_plan_list ([PropertiesPropertyIdGet200ResponseProductListInnerRatePlanListInner]): The rate plans for this product.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            is_los_pricing (bool): Whether this product is length of stay pricing.. [optional]  # noqa: E501
            is_obp_pricing (bool): Whether this product is occupancy based pricing.. [optional]  # noqa: E501
            policy_info (PropertiesPropertyIdGet200ResponseProductListInnerPolicyInfo): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.property_id = property_id
        self.name = name
        self.meal_plan_list = meal_plan_list
        self.room_type_list = room_type_list
        self.rate_plan_list = rate_plan_list
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
