"""
    lodgea-python

    LODGEA SDK for Python. Check out https://docs.lodgea.io for more information.  # noqa: E501

    The version of the OpenAPI document: 1.1.0
    Contact: support@lodgea.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from lodgea-python.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from lodgea-python.exceptions import ApiAttributeError



class PropertiesPropertyIdGet200ResponsePropertyPolicyListInnerTaxPolicyListInner(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('type_code',): {
            '1': 1,
            '3': 3,
            '4': 4,
            '5': 5,
            '6': 6,
            '7': 7,
            '8': 8,
            '10': 10,
            '13': 13,
            '15': 15,
            '17': 17,
            '18': 18,
            '19': 19,
            '28': 28,
            '30': 30,
            '35': 35,
            '36': 36,
            '39': 39,
            '43': 43,
            '46': 46,
            '5001': 5001,
            '5002': 5002,
            '5004': 5004,
            '5007': 5007,
            '5008': 5008,
        },
        ('charge_type',): {
            'INCLUDED': "included",
            'EXCLUDED': "excluded",
            'CONDITIONAL': "conditional",
        },
        ('charge_frequency_code',): {
            '1': 1,
            '2': 2,
            '7': 7,
            '10': 10,
            '12': 12,
            '17': 17,
            '19': 19,
            '20': 20,
            '21': 21,
            '25': 25,
            '31': 31,
            '5000': 5000,
            '5001': 5001,
            '5002': 5002,
            '5010': 5010,
            '5011': 5011,
            '5012': 5012,
            '5013': 5013,
            '5014': 5014,
            '5015': 5015,
            '5016': 5016,
            '5017': 5017,
            '90010': 90010,
            '90011': 90011,
            '90012': 90012,
            '90013': 90013,
        },
        ('currency_code',): {
            'AED': "AED",
            'ARS': "ARS",
            'AUD': "AUD",
            'AZN': "AZN",
            'BGN': "BGN",
            'BHD': "BHD",
            'BRL': "BRL",
            'CAD': "CAD",
            'CHF': "CHF",
            'CLP': "CLP",
            'CNY': "CNY",
            'COP': "COP",
            'CZK': "CZK",
            'DKK': "DKK",
            'EGP': "EGP",
            'EUR': "EUR",
            'FJD': "FJD",
            'GBP': "GBP",
            'GEL': "GEL",
            'HKD': "HKD",
            'HUF': "HUF",
            'IDR': "IDR",
            'ILS': "ILS",
            'INR': "INR",
            'JOD': "JOD",
            'JPY': "JPY",
            'KRW': "KRW",
            'KWD': "KWD",
            'KZT': "KZT",
            'MDL': "MDL",
            'MXN': "MXN",
            'MYR': "MYR",
            'NAD': "NAD",
            'NOK': "NOK",
            'NZD': "NZD",
            'OMR': "OMR",
            'PLN': "PLN",
            'QAR': "QAR",
            'RON': "RON",
            'RUB': "RUB",
            'SAR': "SAR",
            'SEK': "SEK",
            'SGD': "SGD",
            'THB': "THB",
            'TRY': "TRY",
            'TWD': "TWD",
            'UAH': "UAH",
            'USD': "USD",
            'XOF': "XOF",
            'ZAR': "ZAR",
        },
        ('condition_list',): {
            'BRINGS_PET': "guest_brings_pet",
            'DOESNT_CLEAN_BEFORE_CHECKOUT': "guest_doesnt_clean_before_checkout",
            'SMOKES': "guest_smokes",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'type_code': (float,),  # noqa: E501
            'charge_type': (str,),  # noqa: E501
            'charge_frequency_code': (float,),  # noqa: E501
            'currency_code': (str,),  # noqa: E501
            'condition_list': ([str],),  # noqa: E501
            'percent': (float,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'type_code': 'typeCode',  # noqa: E501
        'charge_type': 'chargeType',  # noqa: E501
        'charge_frequency_code': 'chargeFrequencyCode',  # noqa: E501
        'currency_code': 'currencyCode',  # noqa: E501
        'condition_list': 'conditionList',  # noqa: E501
        'percent': 'percent',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, type_code, charge_type, charge_frequency_code, currency_code, condition_list, *args, **kwargs):  # noqa: E501
        """PropertiesPropertyIdGet200ResponsePropertyPolicyListInnerTaxPolicyListInner - a model defined in OpenAPI

        Args:
            type_code (float): The code that represents the type of tax.<p>See also <a href=\"#taxtype-codes\">in the appendix</a>.</p>
            charge_type (str): The type of charge.
            charge_frequency_code (float): The code that represents the frequency of charge.<p>See also <a href=\"#chargetype-codes\">in the appendix</a>.</p>
            currency_code (str): The currency code of the currency in that the charge is applied.<p>See also <a href=\"#currencycodes\">in the appendix</a>.</p>
            condition_list ([str]): A list of conditions for the tax. Is empty if <code>chargeType</code> is not <code>conditional</code>.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            percent (float): The charged percentage if applicable.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.type_code = type_code
        self.charge_type = charge_type
        self.charge_frequency_code = charge_frequency_code
        self.currency_code = currency_code
        self.condition_list = condition_list
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, type_code, charge_type, charge_frequency_code, currency_code, condition_list, *args, **kwargs):  # noqa: E501
        """PropertiesPropertyIdGet200ResponsePropertyPolicyListInnerTaxPolicyListInner - a model defined in OpenAPI

        Args:
            type_code (float): The code that represents the type of tax.<p>See also <a href=\"#taxtype-codes\">in the appendix</a>.</p>
            charge_type (str): The type of charge.
            charge_frequency_code (float): The code that represents the frequency of charge.<p>See also <a href=\"#chargetype-codes\">in the appendix</a>.</p>
            currency_code (str): The currency code of the currency in that the charge is applied.<p>See also <a href=\"#currencycodes\">in the appendix</a>.</p>
            condition_list ([str]): A list of conditions for the tax. Is empty if <code>chargeType</code> is not <code>conditional</code>.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            percent (float): The charged percentage if applicable.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.type_code = type_code
        self.charge_type = charge_type
        self.charge_frequency_code = charge_frequency_code
        self.currency_code = currency_code
        self.condition_list = condition_list
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
